<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>


<% 
/////////////////////////////////////////////////////////////////////////////
//                                devreg.aspx
//                            -------------------
//   begin                : Thur, July 12, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: devreg.aspx,v 1.0.0.0 R1
//   Function: Device Registration and update file.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
    
MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();

String Mac = Request["Mac"];
String D_IP = "";
String Host = RandomNumber(10000, 100000).ToString();
String Dom = "";
if ((Mac == null) || (Mac == ""))
{
    Response.Write("Fail");
    Response.End();
}
else { 
    String encMac = sd.base64_decode(Mac);
    Mac = sd.DeCrypter(encMac);
}
if (IsOKinput(Mac) == false) {
    Response.Write("Fail");
    Response.End();
}
String MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();

//IP detection
    if (MyIP != null)
    {
        MyIP = MyIP.ToLower();
        MyIP = MyIP.Trim();
    }

    if ((MyIP == null) || (MyIP == "unknown")) { MyIP = Request.ServerVariables["REMOTE_ADDR"]; }

    else if (MyIP.IndexOf(",") != -1)
    {
        string[] IPs = MyIP.Split(',');
        //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
          MyIP = IPs.GetValue(0).ToString().Trim();
    }
    if (sd.IsValidIPAddress(MyIP) != "True") { 
        Response.Write("Fail");
        Response.End();
    }
    SqlCommand Recc = new SqlCommand("Dom_Look_Maker", Conn);
    SqlDataReader DRead = Recc.ExecuteReader();
    if (DRead.HasRows == false)
    {
        Response.Write("Fail");
        Response.End();
    }
    while (DRead.Read())
    {
        if ((DRead["Dom"].ToString() == null) || ((DRead["Dom"].ToString() == "")))
        {
            Response.Write("Fail");
            Response.End();
        }
        Dom = DRead["Dom"].ToString();
    
    }
    DRead.Close();
    Recc.Dispose();
   Start:
    SqlCommand Recb = new SqlCommand("Dev_Look_Maker @Host='" + Host + "'", Conn);
    SqlDataReader RecRead = Recb.ExecuteReader();
    while (RecRead.Read())
    {
        if ((RecRead["Host"].ToString() != null) && ((RecRead["Host"].ToString() != "")))
        {
            Host = RandomNumber(10000, 100000).ToString();
            goto Start;
        }
}
    RecRead.Close();
    Recb.Dispose();
    
    //Device Lookup
    SqlCommand Reclook = new SqlCommand("Dev_Maker @Mac='" + Mac + "', @Host='" + Host + "', @Dom='" + Dom + "', @IP='" + MyIP + "'", Conn);
    SqlDataReader RecSet = Reclook.ExecuteReader();
    if (RecSet.HasRows == false) { 
        sd.CreateARecord(Host, Dom, MyIP);
        Response.Write(Host + "." + Dom);
    }
    
    while (RecSet.Read()) {
     D_IP = RecSet["IP"].ToString();
     Host = RecSet["Host"].ToString();
     Dom = RecSet["Dom"].ToString();

     if (RecSet["Disabled"].ToString() == "True")
     {
         Response.Write("Fail");
         Response.End();
     }  
        
        
     if (MyIP != D_IP) { sd.UpdateARecord(Host, Dom, MyIP); }
     Response.Write(Host + "." + Dom);
    }
    RecSet.Close();
    Reclook.Dispose();
   
    Conn.Close();
    Dispose();
%>
<script runat="server">
    //Validate input + cross site scriptng block.
   bool IsOKinput(string input){

   if ((input.Substring(0,1) == ":") || (input.Substring(input.Length - 1) == ":")){ return false;}
          
          if ((input == null) || (input == "")) { return false; }
          if (input.Length >= 64) { return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
                   if (nChar != 58) {
              if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }   
              else { return false; }
                   }   
                }
                return true;   
            }
    private int RandomNumber(int min, int max)
    {
        Random random = new Random();
        return random.Next(min, max);
    }
</script>