<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!--#include file="includes/summaryheader.aspx"-->
<!--#include file="includes/css.aspx"-->

<% 
/////////////////////////////////////////////////////////////////////////////
//                                summary.aspx
//                            -------------------
//   begin                : Thur, June 19, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: summary.aspx,v 1.0.0.0 R1
//   Function: Administration summary page.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
    

if (Request.Cookies["DDNSADMIN"] == null) { Response.Redirect("default.aspx?error=session"); }
String Userid = Request.Cookies["DDNSADMIN"]["user"].ToString();
String Password = Request.Cookies["DDNSADMIN"]["pass"].ToString();
int Users = 0;
int SysDomains = 0;
int UserDomains = 0;
int Records = 0;
int AllDOms = 0;
int Height_of_highest_bar = 100;
int Maximum = 0;
int Image = 1;
int Divider = 0;
String GifFil = "";
String TodayUpdates = "<font color=red>0</font>";
String TodayUsers = "<font color=red>0</font>";
String TodayRecords = "<font color=red>0</font>";
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();


SqlCommand Ulook = new SqlCommand("Admin_Lookup @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) { Response.Redirect("default.aspx?error=session"); }
    UlookSet.Close();
    Ulook.Dispose();




    SqlCommand Sumlook = new SqlCommand("Summary_Display", Conn);
    SqlDataReader SumSet = Sumlook.ExecuteReader();
    if (SumSet.HasRows == false) {  }
    else if (SumSet.Read()){
    Users = Convert.ToInt32(SumSet["UserCount"].ToString());
    SysDomains = Convert.ToInt32(SumSet["SysDomainCount"].ToString());
    UserDomains = Convert.ToInt32(SumSet["UserDomainCount"].ToString());
    Records = Convert.ToInt32(SumSet["RecordCount"].ToString());
    if (Convert.ToInt32(SumSet["TodayUpdates"].ToString()) != 0){TodayUpdates = "<font color=green>" + SumSet["TodayUpdates"].ToString() + "</font>";}   
    if (Convert.ToInt32(SumSet["TodayUsers"].ToString()) != 0){TodayUsers = "<font color=green>" + SumSet["TodayUsers"].ToString() + "</font>";} 
    if (Convert.ToInt32(SumSet["TodayRecords"].ToString()) != 0){TodayRecords = "<font color=green>" + SumSet["TodayRecords"].ToString() + "</font>";}    
        }
    SumSet.Close();
    Sumlook.Dispose();
    AllDOms = UserDomains + SysDomains;

    int[] DNS_Array = new int[3] {Records, Users, AllDOms};
    int[] DNSHeight = new int[3] {0, 0, 0};
    
    if ( DNS_Array[0] >= DNS_Array[1] ) { Maximum = DNS_Array[0]; }
    else { Maximum = DNS_Array[1]; }

 
    
  for (int i = 0; i < DNS_Array.Length; i++)
        {
            try
            {
                DNSHeight[i] = Convert.ToInt32(Convert.ToDecimal(DNS_Array[i]) / Maximum * 100);
            }
            catch { }

            if (DNSHeight[i] <= 1) { DNSHeight[i] = 1; }
        }  
%>
 <p>&nbsp;</p>
<p style="text-align:center">
  <table id="summarytable" cellspacing="0">
  <caption style="width: 274px">DNS and Database Usage</caption>
  <tr>
  
  <th scope="col" colspan="3">
	System Usage Summary</th></tr>
	
	<th scope="row" class="spec" width="117">
  DNS Records:</th>
	<td class="rowb" style="text-align:center"><img src="images/green.gif" width="5" height="5"></td>
  <td class="rowb" align="center" rowspan="5" width="119" valign="bottom">
  <table id="Table1" cellspacing="0">
  <table id="Table2" cellspacing="0">
  <TR>  
<%
    for (int i = 0; i < DNS_Array.Length; i++)
        {
            if ( Image == 1 ){GifFil = "green.gif";}
            if ( Image == 2 ){GifFil = "blue.gif";}
            if ( Image == 3 ){GifFil = "red.gif";}
            Image = Image + 1;   
        
 %>
  <td valign="bottom"><img src="images/<%=GifFil%>" width=20 height="<%=DNSHeight[i]%>"></td>
  <%}%>
   <TR>
  <%for (int i = 0; i < DNS_Array.Length; i++)
    {%>
  <TD><font face="Arial" style="font-size: 9pt"><CENTER><%=DNS_Array[i]%></CENTER></FONT></TD>
  <%}%>  
  </TABLE>
 

</td>
  
	<tr>
	<th scope="row" class="spec" align="left" width="117">
  Users:</th>
	<td class="rowb" style="text-align:center">
  <img src="images/blue.gif" width="5" height="5"/></td>
  </tr>
	<tr>
	<th scope="row" class="spec" align="left" width="117">
  Domains:</th>
	<td class="rowb" style="text-align:center">
  <img src="images/red.gif" width="5" height="5"></td>
  </tr>
	
	<tr>
	<th scope="col" class="nobg"  width="80" colspan="2" valign="top">
  Totals:</th>
  </tr>
  
</table>
</p>
<p style="text-align:center"><center>
<table id="summarytable" cellspacing="0">
  <caption style="width: 274px">24 Hour Usage History</caption>
<th scope="col" colspan="2">Quick Stats</th>
<tr>
<th scope="row" class="spec" width="50%">DNS Updates:</th>
<td class="rowb" style="text-align:center;width:50px"><%=TodayUpdates %></td>
</tr>
<tr>
<th scope="row" class="spec" width="50%">New Users:</th>
<td class="rowb" style="text-align:center;width:50px"><%=TodayUsers %></td>
</tr>
<tr>
<th scope="row" class="spec" width="50%">New DNS Records:</th>
<td class="rowb" style="text-align:center;width:50px"><%=TodayRecords%></td>
</tr>

</table></center>
  </p>
<p>&nbsp;</p> 
<p>&nbsp;</p>   
    <%

    
    Conn.Close();
    Dispose();
    
%>
<!--#include file="includes/summaryfooter.aspx"-->