<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                logonaction.aspx
//                            -------------------
//   begin                : Thur, June 11, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: logonaction.aspx,v 1.0.0.0 R1
//   Function: User logon action file.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
    
MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();
String City = ""; 
String Region =  "";  
String Country =  "";
String Latitude = "";
String Longitude = "";       
String Userid = Request["userid"];
String Password = Request["password"];
String Password1 = "";
String Mac = Request["Mac"];

if ((Mac != null) && (Mac != ""))
{
    String encMac = sd.base64_decode(Mac);
    Mac = sd.DeCrypter(encMac);
    if (Mac_Check(Mac) == false) { Mac = ""; }

}       
    
String MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
HttpCookie IsCookEn = Request.Cookies["CookieCheck"];
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();


    
    if ((Userid == null) || (Userid == "")) { Response.Redirect("logon.aspx?error=fields"); }
    if ((Password == null) || (Password == "")) { Response.Redirect("logon.aspx?error=fields"); }
    if (Userid != null) { Userid = Userid.ToLower(); }
    if (Password != null) { Password1 = sd.base64_encode(Password); }
    if ((CharCheck(Userid) == false) || (CharCheck(Password) == false)){ Response.Redirect("logon.aspx?error=inval"); } 
    if (IsCookEn == null){ Response.Redirect("nocookie.aspx"); }  
    
    if (MyIP != null)
    {
    MyIP = MyIP.ToLower();
    MyIP = MyIP.Trim();
    }
    
    if ((MyIP == null) || (MyIP == "unknown")){ MyIP = Request.ServerVariables["REMOTE_ADDR"]; }
    
    else if (MyIP.IndexOf(",") != -1)
    {
        string[] IPs = MyIP.Split(',');
        //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
          MyIP = IPs.GetValue(0).ToString().Trim();
    }
    //User Check
    SqlCommand Ulook = new SqlCommand("User_Lookup @UserID='" + Userid + "', @Password='" + Password1 + "'", Conn);
    SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) { Response.Redirect("logon.aspx?error=user"); }
    else 
        {
            Response.Cookies["DDNS"]["user"] = Userid;
            Response.Cookies["DDNS"]["pass"] = Password1;
            Response.Cookies["DDNS"].Expires = DateTime.Now.AddDays(1d);
        }
    UlookSet.Close();
    Ulook.Dispose();
    
    //GeoIP Lookup
    SqlCommand GeoLook = new SqlCommand("Lookup_geoip @IP='" + MyIP + "'", Conn);
    SqlDataReader GeoSet = GeoLook.ExecuteReader();
    while (GeoSet.Read() == true) 
    {
        City = GeoSet["city"].ToString();
        Region = GeoSet["region"].ToString();
        Country = GeoSet["country"].ToString();
        Latitude = GeoSet["latitude"].ToString();
        Longitude = GeoSet["longitude"].ToString();  
    }
    GeoSet.Close();
    GeoLook.Dispose();

    //GeoIP Lookup
    SqlCommand LocUp = new SqlCommand("Logon_Update @UserID='" + Userid + "', @Country='" + Country + "', @City='" + City + "', @Region='" + Region + "', @Latitude='" + Latitude + "', @Longitude='" + Longitude + "', @IP='" + MyIP + "'", Conn);
    SqlDataReader LocSet = LocUp.ExecuteReader();
    LocSet.Close();
    LocUp.Dispose();
    
    if ((Mac != null) && (Mac != ""))
    {
        SqlCommand MacUp = new SqlCommand("Mac_Adder @UserID='" + Userid + "', @Password='" + Password1 + "', @Mac='" + Mac + "'", Conn);
        SqlDataReader MacSet = MacUp.ExecuteReader();
        MacSet.Close();
        MacUp.Dispose();
    } 
    
    Response.Redirect("devices.aspx");

    Conn.Close();
    Dispose();
   
 %>
 
<script runat="server">
    //Validate input + cross site scriptng block.
     bool CharCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }
    
    bool Mac_Check(string input)
    {

        if ((input.Substring(0, 1) == ":") || (input.Substring(input.Length - 1) == ":")) { return false; }

        if ((input == null) || (input == "")) { return false; }
        if (input.Length >= 64) { return false; }
        int nChar;
        input = input.ToLower();
        foreach (char i in input)
        {
            nChar = Convert.ToInt32(i);
            if (nChar != 58)
            {
                if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }
                else { return false; }
            }
        }
        return true;
    }
</script>