<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                regaction.aspx
//                            -------------------
//   begin                : Thur, June 14, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: regaction.aspx,v 1.0.0.0 R1
//   Function: User logon action file.
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();
String City = ""; 
String Region =  "";  
String Country =  "";
String Latitude = "";
String Longitude = "";       
String Userid = Request["userid"];
String Password = Request["pass"];
String ConfiPass = Request["passconfirm"];
String Password1 = "";
String FName = Request["fname"];
String LName = Request["lname"];
String Question = Request["question"];
String Answer = Request["answer"];
String Catptcha = Request["captcha"];
String Mac = Request["Mac"];  
    
if ((Mac != null) && (Mac != "")){
    String encMac = sd.base64_decode(Mac);
    Mac = sd.DeCrypter(encMac);
    if (Mac_Check(Mac) == false) { Mac = ""; }

}    
    
    
    
String MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
HttpCookie IsCookEn = Request.Cookies["CookieCheck"];
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();


if (Password != ConfiPass) { Response.Redirect("reg.aspx?error=pass"); }
if ((Userid == null) || (Userid == "") || (Password == null) || (Password == "")) { Response.Redirect("reg.aspx?error=fields"); }
if ((FName == null) || (FName == "") || (LName == null) || (LName == "")) { Response.Redirect("reg.aspx?error=fields"); }
if ((Question == null) || (Question == "") || (Answer == null) || (Answer == "")) { Response.Redirect("reg.aspx?error=fields"); }
if ((UserPassCheck(Userid) == false) || (UserPassCheck(Password) == false) || (CharCheck(FName) == false) || (CharCheck(LName) == false) || (CharCheck(Question) == false) || (CharCheck(Answer) == false)) { Response.Redirect("reg.aspx?error=inval"); } 
if (Userid != null) { Userid = Userid.ToLower(); }
if (Answer != null) 
{ 
    Answer = Answer.ToLower();
    Answer = sd.base64_encode(Answer); 
}

//if (Session["captchastr"].ToString() != Catptcha) { Response.Redirect("reg.aspx?error=captcha"); }

    if (Password != null) { Password1 = sd.base64_encode(Password); }
    
   
    
    if (IsCookEn == null){ Response.Redirect("nocookie.aspx"); }  
    
    if (MyIP != null)
    {
    MyIP = MyIP.ToLower();
    MyIP = MyIP.Trim();
    }
    
    if ((MyIP == null) || (MyIP == "unknown")){ MyIP = Request.ServerVariables["REMOTE_ADDR"]; }
    
    else if (MyIP.IndexOf(",") != -1)
    {
        string[] IPs = MyIP.Split(',');
        //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
          MyIP = IPs.GetValue(0).ToString().Trim();
    }
    
    //GeoIP Lookup
    SqlCommand GeoLook = new SqlCommand("Lookup_geoip @IP='" + MyIP + "'", Conn);
    SqlDataReader GeoSet = GeoLook.ExecuteReader();
    while (GeoSet.Read() == true) 
    {
        City = GeoSet["city"].ToString();
        Region = GeoSet["region"].ToString();
        Country = GeoSet["country"].ToString();
        Latitude = GeoSet["latitude"].ToString();
        Longitude = GeoSet["longitude"].ToString();  
    }
    GeoSet.Close();
    GeoLook.Dispose();

    //GeoIP Lookup
    SqlCommand LocUp = new SqlCommand("Add_User @UserID='" + Userid + "', @Password='" + Password1 + "', @FName='" + FName + "', @LName='" + LName + "', @Question='" + Question + "', @Answer='" + Answer + "', @Country='" + Country + "', @Region='" + Region + "', @City='" + City + "', @Latitude='" + Latitude + "', @Longitude='" + Longitude + "', @IP='" + MyIP + "'", Conn);
    SqlDataReader LocSet = LocUp.ExecuteReader();
    if (LocSet.HasRows != false) { Response.Redirect("reg.aspx?error=used"); }
    else 
    {
        Response.Cookies["DDNS"]["user"] = Userid;
        Response.Cookies["DDNS"]["pass"] = Password1;
        Response.Cookies["DDNS"].Expires = DateTime.Now.AddDays(1d);
    }
    LocSet.Close();
    LocUp.Dispose();

    if ((Mac != null) && (Mac != ""))
    {
        SqlCommand MacUp = new SqlCommand("Mac_Adder @UserID='" + Userid + "', @Password='" + Password1 + "', @Mac='" + Mac + "'", Conn);
        SqlDataReader MacSet = MacUp.ExecuteReader();
        MacSet.Close();
        MacUp.Dispose();
    } 
    
    Response.Redirect("devices.aspx");

    Conn.Close();
    Dispose();
   
 %>
 
<script runat="server">
    //Validate input + cross site scriptng block.
     bool CharCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
         if (input.Length >= 255){ return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
               
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }
     bool UserPassCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
         if (input.Length >= 255){ return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
               if (nChar == 32) { return false; }
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }
    bool Mac_Check(string input)
    {

        if ((input.Substring(0, 1) == ":") || (input.Substring(input.Length - 1) == ":")) { return false; }

        if ((input == null) || (input == "")) { return false; }
        if (input.Length >= 64) { return false; }
        int nChar;
        input = input.ToLower();
        foreach (char i in input)
        {
            nChar = Convert.ToInt32(i);
            if (nChar != 58)
            {
                if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }
                else { return false; }
            }
        }
        return true;
    }
    
</script>